]> git.ipfire.org Git - people/ms/u-boot.git/blob - MAKEALL
serial: mips: Implement CONFIG_SERIAL_MULTI into asc serial driver
[people/ms/u-boot.git] / MAKEALL
1 #!/bin/bash
2 # Tool mainly for U-Boot Quality Assurance: build one or more board
3 # configurations with minimal verbosity, showing only warnings and
4 # errors.
5
6 usage()
7 {
8 # if exiting with 0, write to stdout, else write to stderr
9 local ret=${1:-0}
10 [ "${ret}" -eq 1 ] && exec 1>&2
11 cat <<-EOF
12 Usage: MAKEALL [options] [--] [boards-to-build]
13
14 Options:
15 -a ARCH, --arch ARCH Build all boards with arch ARCH
16 -c CPU, --cpu CPU Build all boards with cpu CPU
17 -v VENDOR, --vendor VENDOR Build all boards with vendor VENDOR
18 -s SOC, --soc SOC Build all boards with soc SOC
19 -l, --list List all targets to be built
20 -m, --maintainers List all targets and maintainer email
21 -M, --mails List all targets and all affilated emails
22 -h, --help This help output
23
24 Selections by these options are logically ANDed; if the same option
25 is used repeatedly, such selections are ORed. So "-v FOO -v BAR"
26 will select all configurations where the vendor is either FOO or
27 BAR. Any additional arguments specified on the command line are
28 always build additionally. See the boards.cfg file for more info.
29
30 If no boards are specified, then the default is "powerpc".
31
32 Environment variables:
33 BUILD_NCPUS number of parallel make jobs (default: auto)
34 CROSS_COMPILE cross-compiler toolchain prefix (default: "")
35 MAKEALL_LOGDIR output all logs to here (default: ./LOG/)
36 BUILD_DIR output build directory (default: ./)
37 BUILD_NBUILDS number of parallel targets (default: 1)
38
39 Examples:
40 - build all Power Architecture boards:
41 MAKEALL -a powerpc
42 MAKEALL --arch powerpc
43 MAKEALL powerpc
44 - build all PowerPC boards manufactured by vendor "esd":
45 MAKEALL -a powerpc -v esd
46 - build all PowerPC boards manufactured either by "keymile" or "siemens":
47 MAKEALL -a powerpc -v keymile -v siemens
48 - build all Freescale boards with MPC83xx CPUs, plus all 4xx boards:
49 MAKEALL -c mpc83xx -v freescale 4xx
50 EOF
51 exit ${ret}
52 }
53
54 SHORT_OPTS="ha:c:v:s:lmM"
55 LONG_OPTS="help,arch:,cpu:,vendor:,soc:,list,maintainers,mails"
56
57 # Option processing based on util-linux-2.13/getopt-parse.bash
58
59 # Note that we use `"$@"' to let each command-line parameter expand to a
60 # separate word. The quotes around `$@' are essential!
61 # We need TEMP as the `eval set --' would nuke the return value of
62 # getopt.
63 TEMP=`getopt -o ${SHORT_OPTS} --long ${LONG_OPTS} \
64 -n 'MAKEALL' -- "$@"`
65
66 [ $? != 0 ] && usage 1
67
68 # Note the quotes around `$TEMP': they are essential!
69 eval set -- "$TEMP"
70
71 SELECTED=''
72 ONLY_LIST=''
73 PRINT_MAINTS=''
74 MAINTAINERS_ONLY=''
75
76 while true ; do
77 case "$1" in
78 -a|--arch)
79 # echo "Option ARCH: argument \`$2'"
80 if [ "$opt_a" ] ; then
81 opt_a="${opt_a%)} || \$2 == \"$2\")"
82 else
83 opt_a="(\$2 == \"$2\")"
84 fi
85 SELECTED='y'
86 shift 2 ;;
87 -c|--cpu)
88 # echo "Option CPU: argument \`$2'"
89 if [ "$opt_c" ] ; then
90 opt_c="${opt_c%)} || \$3 == \"$2\" || \$3 ~ /$2:/)"
91 else
92 opt_c="(\$3 == \"$2\" || \$3 ~ /$2:/)"
93 fi
94 SELECTED='y'
95 shift 2 ;;
96 -s|--soc)
97 # echo "Option SoC: argument \`$2'"
98 if [ "$opt_s" ] ; then
99 opt_s="${opt_s%)} || \$6 == \"$2\")"
100 else
101 opt_s="(\$6 == \"$2\")"
102 fi
103 SELECTED='y'
104 shift 2 ;;
105 -v|--vendor)
106 # echo "Option VENDOR: argument \`$2'"
107 if [ "$opt_v" ] ; then
108 opt_v="${opt_v%)} || \$5 == \"$2\")"
109 else
110 opt_v="(\$5 == \"$2\")"
111 fi
112 SELECTED='y'
113 shift 2 ;;
114 -l|--list)
115 ONLY_LIST='y'
116 shift ;;
117 -m|--maintainers)
118 ONLY_LIST='y'
119 PRINT_MAINTS='y'
120 MAINTAINERS_ONLY='y'
121 shift ;;
122 -M|--mails)
123 ONLY_LIST='y'
124 PRINT_MAINTS='y'
125 shift ;;
126 -h|--help)
127 usage ;;
128 --)
129 shift ; break ;;
130 *)
131 echo "Internal error!" >&2 ; exit 1 ;;
132 esac
133 done
134 # echo "Remaining arguments:"
135 # for arg do echo '--> '"\`$arg'" ; done
136
137 FILTER="\$1 !~ /^#/"
138 [ "$opt_a" ] && FILTER="${FILTER} && $opt_a"
139 [ "$opt_c" ] && FILTER="${FILTER} && $opt_c"
140 [ "$opt_s" ] && FILTER="${FILTER} && $opt_s"
141 [ "$opt_v" ] && FILTER="${FILTER} && $opt_v"
142
143 if [ "$SELECTED" ] ; then
144 SELECTED=$(awk '('"$FILTER"') { print $1 }' boards.cfg)
145
146 # Make sure some boards from boards.cfg are actually found
147 if [ -z "$SELECTED" ] ; then
148 echo "Error: No boards selected, invalid arguments"
149 exit 1
150 fi
151 fi
152
153 #########################################################################
154
155 # Print statistics when we exit
156 trap exit 1 2 3 15
157 trap print_stats 0
158
159 # Determine number of CPU cores if no default was set
160 : ${BUILD_NCPUS:="`getconf _NPROCESSORS_ONLN`"}
161
162 if [ "$BUILD_NCPUS" -gt 1 ]
163 then
164 JOBS="-j $((BUILD_NCPUS + 1))"
165 else
166 JOBS=""
167 fi
168
169
170 if [ "${CROSS_COMPILE}" ] ; then
171 MAKE="make CROSS_COMPILE=${CROSS_COMPILE}"
172 else
173 MAKE=make
174 fi
175
176 if [ "${MAKEALL_LOGDIR}" ] ; then
177 LOG_DIR=${MAKEALL_LOGDIR}
178 else
179 LOG_DIR="LOG"
180 fi
181
182 : ${BUILD_NBUILDS:=1}
183 BUILD_MANY=0
184
185 if [ "${BUILD_NBUILDS}" -gt 1 ] ; then
186 BUILD_MANY=1
187 : ${BUILD_DIR:=./build}
188 mkdir -p "${BUILD_DIR}/ERR"
189 find "${BUILD_DIR}/ERR/" -type f -exec rm -f {} +
190 fi
191
192 : ${BUILD_DIR:=.}
193
194 OUTPUT_PREFIX="${BUILD_DIR}"
195
196 [ -d ${LOG_DIR} ] || mkdir "${LOG_DIR}" || exit 1
197 find "${LOG_DIR}/" -type f -exec rm -f {} +
198
199 LIST=""
200
201 # Keep track of the number of builds and errors
202 ERR_CNT=0
203 ERR_LIST=""
204 WRN_CNT=0
205 WRN_LIST=""
206 TOTAL_CNT=0
207 CURRENT_CNT=0
208 OLDEST_IDX=1
209 RC=0
210
211 # Helper funcs for parsing boards.cfg
212 boards_by_field()
213 {
214 FS="[ \t]+"
215 [ -n "$3" ] && FS="$3"
216 awk \
217 -v field="$1" \
218 -v select="$2" \
219 -F "$FS" \
220 '($1 !~ /^#/ && $field == select) { print $1 }' \
221 boards.cfg
222 }
223 boards_by_arch() { boards_by_field 2 "$@" ; }
224 boards_by_cpu() { boards_by_field 3 "$@" "[: \t]+" ; }
225 boards_by_soc() { boards_by_field 6 "$@" ; }
226
227 #########################################################################
228 ## MPC5xx Systems
229 #########################################################################
230
231 LIST_5xx="$(boards_by_cpu mpc5xx)"
232
233 #########################################################################
234 ## MPC5xxx Systems
235 #########################################################################
236
237 LIST_5xxx="$(boards_by_cpu mpc5xxx)"
238
239 #########################################################################
240 ## MPC512x Systems
241 #########################################################################
242
243 LIST_512x="$(boards_by_cpu mpc512x)"
244
245 #########################################################################
246 ## MPC8xx Systems
247 #########################################################################
248
249 LIST_8xx="$(boards_by_cpu mpc8xx)"
250
251 #########################################################################
252 ## PPC4xx Systems
253 #########################################################################
254
255 LIST_4xx="$(boards_by_cpu ppc4xx)"
256
257 #########################################################################
258 ## MPC8220 Systems
259 #########################################################################
260
261 LIST_8220="$(boards_by_cpu mpc8220)"
262
263 #########################################################################
264 ## MPC824x Systems
265 #########################################################################
266
267 LIST_824x="$(boards_by_cpu mpc824x)"
268
269 #########################################################################
270 ## MPC8260 Systems (includes 8250, 8255 etc.)
271 #########################################################################
272
273 LIST_8260="$(boards_by_cpu mpc8260)"
274
275 #########################################################################
276 ## MPC83xx Systems (includes 8349, etc.)
277 #########################################################################
278
279 LIST_83xx="$(boards_by_cpu mpc83xx)"
280
281 #########################################################################
282 ## MPC85xx Systems (includes 8540, 8560 etc.)
283 #########################################################################
284
285 LIST_85xx="$(boards_by_cpu mpc85xx)"
286
287 #########################################################################
288 ## MPC86xx Systems
289 #########################################################################
290
291 LIST_86xx="$(boards_by_cpu mpc86xx)"
292
293 #########################################################################
294 ## 74xx/7xx Systems
295 #########################################################################
296
297 LIST_74xx_7xx="$(boards_by_cpu 74xx_7xx)"
298
299 #########################################################################
300 ## PowerPC groups
301 #########################################################################
302
303 LIST_TSEC=" \
304 ${LIST_83xx} \
305 ${LIST_85xx} \
306 ${LIST_86xx} \
307 "
308
309 LIST_powerpc=" \
310 ${LIST_5xx} \
311 ${LIST_512x} \
312 ${LIST_5xxx} \
313 ${LIST_8xx} \
314 ${LIST_8220} \
315 ${LIST_824x} \
316 ${LIST_8260} \
317 ${LIST_83xx} \
318 ${LIST_85xx} \
319 ${LIST_86xx} \
320 ${LIST_4xx} \
321 ${LIST_74xx_7xx}\
322 "
323
324 # Alias "ppc" -> "powerpc" to not break compatibility with older scripts
325 # still using "ppc" instead of "powerpc"
326 LIST_ppc=" \
327 ${LIST_powerpc} \
328 "
329
330 #########################################################################
331 ## StrongARM Systems
332 #########################################################################
333
334 LIST_SA="$(boards_by_cpu sa1100)"
335
336 #########################################################################
337 ## ARM7 Systems
338 #########################################################################
339
340 LIST_ARM7="$(boards_by_cpu arm720t)"
341
342 #########################################################################
343 ## ARM9 Systems
344 #########################################################################
345
346 LIST_ARM9="$(boards_by_cpu arm920t) \
347 $(boards_by_cpu arm926ejs) \
348 $(boards_by_cpu arm925t) \
349 $(boards_by_cpu arm946es) \
350 "
351
352 #########################################################################
353 ## ARM11 Systems
354 #########################################################################
355 LIST_ARM11="$(boards_by_cpu arm1136) \
356 $(boards_by_cpu arm1176) \
357 "
358
359 #########################################################################
360 ## ARMV7 Systems
361 #########################################################################
362
363 LIST_ARMV7="$(boards_by_cpu armv7)"
364
365 #########################################################################
366 ## AT91 Systems
367 #########################################################################
368
369 LIST_at91="$(boards_by_soc at91)"
370
371 #########################################################################
372 ## Xscale Systems
373 #########################################################################
374
375 LIST_pxa="$(boards_by_cpu pxa)"
376
377 LIST_ixp="$(boards_by_cpu ixp)"
378
379 #########################################################################
380 ## ARM groups
381 #########################################################################
382
383 LIST_arm="$(boards_by_arch arm)"
384
385 #########################################################################
386 ## MIPS Systems (default = big endian)
387 #########################################################################
388
389 LIST_mips4kc=" \
390 incaip \
391 incaip_100MHz \
392 incaip_133MHz \
393 incaip_150MHz \
394 qemu_mips \
395 vct_platinum \
396 vct_platinum_small \
397 vct_platinum_onenand \
398 vct_platinum_onenand_small \
399 vct_platinumavc \
400 vct_platinumavc_small \
401 vct_platinumavc_onenand \
402 vct_platinumavc_onenand_small \
403 vct_premium \
404 vct_premium_small \
405 vct_premium_onenand \
406 vct_premium_onenand_small \
407 "
408
409 LIST_au1xx0=" \
410 dbau1000 \
411 dbau1100 \
412 dbau1500 \
413 dbau1550 \
414 "
415
416 LIST_mips=" \
417 ${LIST_mips4kc} \
418 ${LIST_mips5kc} \
419 ${LIST_au1xx0} \
420 "
421
422 #########################################################################
423 ## MIPS Systems (little endian)
424 #########################################################################
425
426 LIST_xburst_el=" \
427 qi_lb60 \
428 "
429
430 LIST_au1xx0_el=" \
431 dbau1550_el \
432 pb1000 \
433 "
434 LIST_mips_el=" \
435 ${LIST_xburst_el} \
436 ${LIST_au1xx0_el} \
437 "
438 #########################################################################
439 ## OpenRISC Systems
440 #########################################################################
441
442 LIST_openrisc="$(boards_by_arch openrisc)"
443
444 #########################################################################
445 ## x86 Systems
446 #########################################################################
447
448 LIST_x86="$(boards_by_arch x86)"
449
450 #########################################################################
451 ## Nios-II Systems
452 #########################################################################
453
454 LIST_nios2="$(boards_by_arch nios2)"
455
456 #########################################################################
457 ## MicroBlaze Systems
458 #########################################################################
459
460 LIST_microblaze="$(boards_by_arch microblaze)"
461
462 #########################################################################
463 ## ColdFire Systems
464 #########################################################################
465
466 LIST_m68k="$(boards_by_arch m68k)"
467 LIST_coldfire=${LIST_m68k}
468
469 #########################################################################
470 ## AVR32 Systems
471 #########################################################################
472
473 LIST_avr32="$(boards_by_arch avr32)"
474
475 #########################################################################
476 ## Blackfin Systems
477 #########################################################################
478
479 LIST_blackfin="$(boards_by_arch blackfin)"
480
481 #########################################################################
482 ## SH Systems
483 #########################################################################
484
485 LIST_sh2="$(boards_by_cpu sh2)"
486 LIST_sh3="$(boards_by_cpu sh3)"
487 LIST_sh4="$(boards_by_cpu sh4)"
488
489 LIST_sh="$(boards_by_arch sh)"
490
491 #########################################################################
492 ## SPARC Systems
493 #########################################################################
494
495 LIST_sparc="$(boards_by_arch sparc)"
496
497 #########################################################################
498 ## NDS32 Systems
499 #########################################################################
500
501 LIST_nds32="$(boards_by_arch nds32)"
502
503 #-----------------------------------------------------------------------
504
505 get_target_location() {
506 local target=$1
507 local BOARD_NAME=""
508 local CONFIG_NAME=""
509 local board=""
510 local vendor=""
511
512 # Automatic mode
513 local line=`egrep -i "^[[:space:]]*${target}[[:space:]]" boards.cfg`
514
515 if [ -z "${line}" ] ; then echo "" ; return ; fi
516
517 set ${line}
518
519 # add default board name if needed
520 [ $# = 3 ] && set ${line} ${1}
521
522 CONFIG_NAME="${1%_config}"
523
524 [ "${BOARD_NAME}" ] || BOARD_NAME="${1%_config}"
525
526 if [ "$4" = "-" ] ; then
527 board=${BOARD_NAME}
528 else
529 board="$4"
530 fi
531
532 [ $# -gt 4 ] && [ "$5" != "-" ] && vendor="$5"
533 [ $# -gt 6 ] && [ "$7" != "-" ] && {
534 tmp="${7%:*}"
535 if [ "$tmp" ] ; then
536 CONFIG_NAME="$tmp"
537 fi
538 }
539
540 # Assign board directory to BOARDIR variable
541 if [ -z "${vendor}" ] ; then
542 BOARDDIR=${board}
543 else
544 BOARDDIR=${vendor}/${board}
545 fi
546
547 echo "${CONFIG_NAME}:${BOARDDIR}"
548 }
549
550 get_target_maintainers() {
551 local name=`echo $1 | cut -d : -f 1`
552
553 if ! grep -qsi "[[:blank:]]${name}[[:blank:]]" MAINTAINERS ; then
554 echo ""
555 return ;
556 fi
557
558 local line=`tac MAINTAINERS | grep -ni "[[:blank:]]${name}[[:blank:]]" | cut -d : -f 1`
559 local mail=`tac MAINTAINERS | tail -n +${line} | \
560 sed -n ":start /.*@.*/ { b mail } ; n ; b start ; :mail /.*@.*/ { p ; n ; b mail } ; q" | \
561 sed "s/^.*<//;s/>.*$//"`
562 echo "$mail"
563 }
564
565 list_target() {
566 if [ "$PRINT_MAINTS" != 'y' ] ; then
567 echo "$1"
568 return
569 fi
570
571 echo -n "$1:"
572
573 local loc=`get_target_location $1`
574
575 if [ -z "${loc}" ] ; then echo "ERROR" ; return ; fi
576
577 local maintainers_result=`get_target_maintainers ${loc} | tr " " "\n"`
578
579 if [ "$MAINTAINERS_ONLY" != 'y' ] ; then
580
581 local dir=`echo ${loc} | cut -d ":" -f 2`
582 local cfg=`echo ${loc} | cut -d ":" -f 1`
583 local git_result=`git log --format=%aE board/${dir} \
584 include/configs/${cfg}.h | grep "@"`
585 local git_result_recent=`echo ${git_result} | tr " " "\n" | \
586 head -n 3`
587 local git_result_top=`echo ${git_result} | tr " " "\n" | \
588 sort | uniq -c | sort -nr | head -n 3 | \
589 sed "s/^ \+[0-9]\+ \+//"`
590
591 echo -e "$git_result_recent\n$git_result_top\n$maintainers_result" | \
592 sort -u | tr "\n" " " | sed "s/ $//" ;
593 else
594 echo -e "$maintainers_result" | sort -u | tr "\n" " " | \
595 sed "s/ $//" ;
596 fi
597
598 echo ""
599 }
600
601 # Each finished build will have a file called ${donep}${n},
602 # where n is the index of the build. Each build
603 # we've already noted as finished will have ${skipp}${n}.
604 # The code managing the build process will use this information
605 # to ensure that only BUILD_NBUILDS builds are in flight at once
606 donep="${LOG_DIR}/._done_"
607 skipp="${LOG_DIR}/._skip_"
608
609 build_target() {
610 target=$1
611 build_idx=$2
612
613 if [ "$ONLY_LIST" == 'y' ] ; then
614 list_target ${target}
615 return
616 fi
617
618 if [ $BUILD_MANY == 1 ] ; then
619 output_dir="${OUTPUT_PREFIX}/${target}"
620 mkdir -p "${output_dir}"
621 else
622 output_dir="${OUTPUT_PREFIX}"
623 fi
624
625 export BUILD_DIR="${output_dir}"
626
627 ${MAKE} distclean >/dev/null
628 ${MAKE} -s ${target}_config
629
630 ${MAKE} ${JOBS} all \
631 >${LOG_DIR}/$target.MAKELOG 2> ${LOG_DIR}/$target.ERR
632
633 # Check for 'make' errors
634 if [ ${PIPESTATUS[0]} -ne 0 ] ; then
635 RC=1
636 fi
637
638 if [ $BUILD_MANY == 1 ] ; then
639 ${MAKE} tidy
640
641 if [ -s ${LOG_DIR}/${target}.ERR ] ; then
642 cp ${LOG_DIR}/${target}.ERR ${OUTPUT_PREFIX}/ERR/${target}
643 else
644 rm ${LOG_DIR}/${target}.ERR
645 fi
646 else
647 if [ -s ${LOG_DIR}/${target}.ERR ] ; then
648 if grep -iw error ${LOG_DIR}/${target}.ERR ; then
649 : $(( ERR_CNT += 1 ))
650 ERR_LIST="${ERR_LIST} $target"
651 else
652 : $(( WRN_CNT += 1 ))
653 WRN_LIST="${WRN_LIST} $target"
654 fi
655 else
656 rm ${LOG_DIR}/${target}.ERR
657 fi
658 fi
659
660 OBJS=${output_dir}/u-boot
661 if [ -e ${output_dir}/spl/u-boot-spl ]; then
662 OBJS="${OBJS} ${output_dir}/spl/u-boot-spl"
663 fi
664
665 ${CROSS_COMPILE}size ${OBJS} | tee -a ${LOG_DIR}/$target.MAKELOG
666
667 [ -e "${LOG_DIR}/${target}.ERR" ] && cat "${LOG_DIR}/${target}.ERR"
668
669 touch "${donep}${build_idx}"
670 }
671
672 manage_builds() {
673 search_idx=${OLDEST_IDX}
674 if [ "$ONLY_LIST" == 'y' ] ; then return ; fi
675
676 while true; do
677 if [ -e "${donep}${search_idx}" ] ; then
678 : $(( CURRENT_CNT-- ))
679 [ ${OLDEST_IDX} -eq ${search_idx} ] &&
680 : $(( OLDEST_IDX++ ))
681
682 # Only want to count it once
683 rm -f "${donep}${search_idx}"
684 touch "${skipp}${search_idx}"
685 elif [ -e "${skipp}${search_idx}" ] ; then
686 [ ${OLDEST_IDX} -eq ${search_idx} ] &&
687 : $(( OLDEST_IDX++ ))
688 fi
689 : $(( search_idx++ ))
690 if [ ${search_idx} -gt ${TOTAL_CNT} ] ; then
691 if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then
692 search_idx=${OLDEST_IDX}
693 sleep 1
694 else
695 break
696 fi
697 fi
698 done
699 }
700
701 build_targets() {
702 for t in "$@" ; do
703 # If a LIST_xxx var exists, use it. But avoid variable
704 # expansion in the eval when a board name contains certain
705 # characters that the shell interprets.
706 case ${t} in
707 *[-+=]*) list= ;;
708 *) list=$(eval echo '${LIST_'$t'}') ;;
709 esac
710 if [ -n "${list}" ] ; then
711 build_targets ${list}
712 else
713 : $((TOTAL_CNT += 1))
714 : $((CURRENT_CNT += 1))
715 rm -f "${donep}${TOTAL_CNT}"
716 rm -f "${skipp}${TOTAL_CNT}"
717 if [ $BUILD_MANY == 1 ] ; then
718 build_target ${t} ${TOTAL_CNT} &
719 else
720 build_target ${t} ${TOTAL_CNT}
721 fi
722 fi
723
724 # We maintain a running count of all the builds we have done.
725 # Each finished build will have a file called ${donep}${n},
726 # where n is the index of the build. Each build
727 # we've already noted as finished will have ${skipp}${n}.
728 # We track the current index via TOTAL_CNT, and the oldest
729 # index. When we exceed the maximum number of parallel builds,
730 # We look from oldest to current for builds that have completed,
731 # and update the current count and oldest index as appropriate.
732 # If we've gone through the entire list, wait a second, and
733 # reprocess the entire list until we find a build that has
734 # completed
735 if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then
736 manage_builds
737 fi
738 done
739 }
740
741 #-----------------------------------------------------------------------
742
743 kill_children() {
744 kill -- "-$1"
745
746 exit
747 }
748
749 print_stats() {
750 if [ "$ONLY_LIST" == 'y' ] ; then return ; fi
751
752 rm -f ${donep}* ${skipp}*
753
754 if [ $BUILD_MANY == 1 ] && [ -e "${OUTPUT_PREFIX}/ERR" ] ; then
755 ERR_LIST=`grep -riwl error ${OUTPUT_PREFIX}/ERR/`
756 ERR_LIST=`for f in $ERR_LIST ; do echo -n " $(basename $f)" ; done`
757 ERR_CNT=`echo $ERR_LIST | wc -w | awk '{print $1}'`
758 WRN_LIST=`grep -riwL error ${OUTPUT_PREFIX}/ERR/`
759 WRN_LIST=`for f in $WRN_LIST ; do echo -n " $(basename $f)" ; done`
760 WRN_CNT=`echo $WRN_LIST | wc -w | awk '{print $1}'`
761 fi
762
763 echo ""
764 echo "--------------------- SUMMARY ----------------------------"
765 echo "Boards compiled: ${TOTAL_CNT}"
766 if [ ${ERR_CNT} -gt 0 ] ; then
767 echo "Boards with errors: ${ERR_CNT} (${ERR_LIST} )"
768 fi
769 if [ ${WRN_CNT} -gt 0 ] ; then
770 echo "Boards with warnings but no errors: ${WRN_CNT} (${WRN_LIST} )"
771 fi
772 echo "----------------------------------------------------------"
773
774 if [ $BUILD_MANY == 1 ] ; then
775 kill_children $$ &
776 fi
777
778 exit $RC
779 }
780
781 #-----------------------------------------------------------------------
782
783 # Build target groups selected by options, plus any command line args
784 set -- ${SELECTED} "$@"
785 # run PowerPC by default
786 [ $# = 0 ] && set -- powerpc
787 build_targets "$@"
788 wait